package de.intevation.flys.artifacts.math.fitting;

public class Linear
extends      Function
{
    public static final Derivative DERIVATIVE =
        new Derivative("W'(Q) = m") {

        @Override
        public de.intevation.flys.artifacts.math.Function
            instantiate(double [] parameters)
        {
            final double m = parameters[0];

            return new de.intevation.flys.artifacts.math.Function() {
                @Override
                public double value(double Q) {
                    return m;
                }
            };
        }
    };

    public Linear() {
        super("linear", "W(Q) = m*Q + b", new String [] { "m", "b" });
    }

    @Override
    public double value(double x, double [] parameters) {
        return x*parameters[0] + parameters[1];
    }

    @Override
    public double [] gradient(double x, double [] parameters) {
        return new double [] { x, 1d };
    }

    @Override
    public Derivative getDerivative() {
        return DERIVATIVE;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
